/* xnoise-mediawatcher.c generated by valac 0.10.0, the Vala compiler
 * generated from xnoise-mediawatcher.vala, do not modify */

/* xnoise-mediawatcher.vala
 *
 * Copyright (C) 2010 softshaker
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 */
/* Mediawatcher is a Plugin that monitors media directories */
/* for changes and updates the db respectively*/
/* TODO
* handle symlinks
* test performance, maybe switch to inotify as an option for linux
* find a well performing facility to automatically add files that were created in the media 
path while xnoise was not monitoring/running (i have no solution here)
* handle directory deletions
* disconnect signal handlers when plugin is unloaded
*/

#include <glib.h>
#include <glib-object.h>
#include <xnoise.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define XNOISE_TYPE_MEDIAWATCHER_PLUGIN (xnoise_mediawatcher_plugin_get_type ())
#define XNOISE_MEDIAWATCHER_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_MEDIAWATCHER_PLUGIN, XnoiseMediawatcherPlugin))
#define XNOISE_MEDIAWATCHER_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_MEDIAWATCHER_PLUGIN, XnoiseMediawatcherPluginClass))
#define XNOISE_IS_MEDIAWATCHER_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_MEDIAWATCHER_PLUGIN))
#define XNOISE_IS_MEDIAWATCHER_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_MEDIAWATCHER_PLUGIN))
#define XNOISE_MEDIAWATCHER_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_MEDIAWATCHER_PLUGIN, XnoiseMediawatcherPluginClass))

typedef struct _XnoiseMediawatcherPlugin XnoiseMediawatcherPlugin;
typedef struct _XnoiseMediawatcherPluginClass XnoiseMediawatcherPluginClass;
typedef struct _XnoiseMediawatcherPluginPrivate XnoiseMediawatcherPluginPrivate;

#define XNOISE_TYPE_MEDIAWATCHER (xnoise_mediawatcher_get_type ())
#define XNOISE_MEDIAWATCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_MEDIAWATCHER, XnoiseMediawatcher))
#define XNOISE_MEDIAWATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_MEDIAWATCHER, XnoiseMediawatcherClass))
#define XNOISE_IS_MEDIAWATCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_MEDIAWATCHER))
#define XNOISE_IS_MEDIAWATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_MEDIAWATCHER))
#define XNOISE_MEDIAWATCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_MEDIAWATCHER, XnoiseMediawatcherClass))

typedef struct _XnoiseMediawatcher XnoiseMediawatcher;
typedef struct _XnoiseMediawatcherClass XnoiseMediawatcherClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _XnoiseMediawatcherPrivate XnoiseMediawatcherPrivate;

#define XNOISE_MEDIAWATCHER_TYPE_DATA_PAIR (xnoise_mediawatcher_data_pair_get_type ())
#define XNOISE_MEDIAWATCHER_DATA_PAIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_MEDIAWATCHER_TYPE_DATA_PAIR, XnoiseMediawatcherDataPair))
#define XNOISE_MEDIAWATCHER_DATA_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_MEDIAWATCHER_TYPE_DATA_PAIR, XnoiseMediawatcherDataPairClass))
#define XNOISE_MEDIAWATCHER_IS_DATA_PAIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_MEDIAWATCHER_TYPE_DATA_PAIR))
#define XNOISE_MEDIAWATCHER_IS_DATA_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_MEDIAWATCHER_TYPE_DATA_PAIR))
#define XNOISE_MEDIAWATCHER_DATA_PAIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_MEDIAWATCHER_TYPE_DATA_PAIR, XnoiseMediawatcherDataPairClass))

typedef struct _XnoiseMediawatcherDataPair XnoiseMediawatcherDataPair;
typedef struct _XnoiseMediawatcherDataPairClass XnoiseMediawatcherDataPairClass;

#define XNOISE_TYPE_IMPORT_INFO_BAR (xnoise_import_info_bar_get_type ())
#define XNOISE_IMPORT_INFO_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_IMPORT_INFO_BAR, XnoiseImportInfoBar))
#define XNOISE_IMPORT_INFO_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_IMPORT_INFO_BAR, XnoiseImportInfoBarClass))
#define XNOISE_IS_IMPORT_INFO_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_IMPORT_INFO_BAR))
#define XNOISE_IS_IMPORT_INFO_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_IMPORT_INFO_BAR))
#define XNOISE_IMPORT_INFO_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_IMPORT_INFO_BAR, XnoiseImportInfoBarClass))

typedef struct _XnoiseImportInfoBar XnoiseImportInfoBar;
typedef struct _XnoiseImportInfoBarClass XnoiseImportInfoBarClass;
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
#define _g_queue_free0(var) ((var == NULL) ? NULL : (var = (g_queue_free (var), NULL)))
#define _xnoise_db_browser_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_db_browser_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _XnoiseMediawatcherDataPairPrivate XnoiseMediawatcherDataPairPrivate;
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _XnoiseMediawatcherStarterMethodAsyncData XnoiseMediawatcherStarterMethodAsyncData;
typedef struct _XnoiseMediawatcherAsyncWorkerData XnoiseMediawatcherAsyncWorkerData;
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_pattern_spec_free0(var) ((var == NULL) ? NULL : (var = (g_pattern_spec_free (var), NULL)))
#define _xnoise_track_data_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_track_data_unref (var), NULL)))
typedef struct _XnoiseMediawatcherAddLocalTagsData XnoiseMediawatcherAddLocalTagsData;
typedef struct _Block3Data Block3Data;
#define _xnoise_tag_reader_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_tag_reader_unref (var), NULL)))
typedef struct _XnoiseImportInfoBarPrivate XnoiseImportInfoBarPrivate;

struct _XnoiseMediawatcherPlugin {
	GObject parent_instance;
	XnoiseMediawatcherPluginPrivate * priv;
	XnoiseMediawatcher* watcher;
};

struct _XnoiseMediawatcherPluginClass {
	GObjectClass parent_class;
};

struct _XnoiseMediawatcherPluginPrivate {
	XnoiseMain* _xn;
};

struct _XnoiseMediawatcher {
	GObject parent_instance;
	XnoiseMediawatcherPrivate * priv;
};

struct _XnoiseMediawatcherClass {
	GObjectClass parent_class;
};

struct _XnoiseMediawatcherPrivate {
	GList* monitor_list;
	XnoiseImportInfoBar* iib;
	GQueue* queue;
	gboolean async_running;
};

struct _XnoiseMediawatcherDataPair {
	GObject parent_instance;
	XnoiseMediawatcherDataPairPrivate * priv;
	GFileMonitor* monitor;
	char* path;
};

struct _XnoiseMediawatcherDataPairClass {
	GObjectClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	XnoiseMediawatcher * self;
	char* path;
};

struct _Block2Data {
	int _ref_count_;
	XnoiseMediawatcher * self;
	gboolean success;
	char* path;
};

struct _XnoiseMediawatcherStarterMethodAsyncData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	XnoiseMediawatcher* self;
	XnoiseWorkerJob* job;
};

struct _XnoiseMediawatcherAsyncWorkerData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	XnoiseMediawatcher* self;
	XnoiseWorkerJob* job;
	char* path;
	GFile* file;
	char* _tmp0_;
	GFileInfo* info;
	char* _tmp1_;
	char* _tmp2_;
	GError * e2;
	GError * _inner_error_;
};

struct _XnoiseMediawatcherAddLocalTagsData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	XnoiseMediawatcher* self;
	GFile* dir;
	GFileEnumerator* enumerator;
	char* attr;
	GFileEnumerator* _tmp0_;
	GFileEnumerator* _tmp1_;
	char* _tmp2_;
	GError * _error_;
	GList* infos;
	GList* _tmp3_;
	GList* _tmp4_;
	XnoiseTrackData* td;
	gint idbuffer;
	char* filename;
	char* filepath;
	char* _tmp5_;
	char* _tmp6_;
	GFile* file;
	GFileType filetype;
	char* content;
	char* mime;
	GPatternSpec* psAudio;
	GPatternSpec* psVideo;
	char* _tmp7_;
	char* uri_lc;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	XnoiseWorkerJob* job;
	char* nm;
	GValue* _tmp12_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* info;
	GError * e;
	GError * _inner_error_;
};

struct _Block3Data {
	int _ref_count_;
	XnoiseMediawatcher * self;
	XnoiseTrackData** tdy;
	gint tdy_length1;
	gint _tdy_size_;
};

struct _XnoiseImportInfoBar {
	GObject parent_instance;
	XnoiseImportInfoBarPrivate * priv;
};

struct _XnoiseImportInfoBarClass {
	GObjectClass parent_class;
};

struct _XnoiseImportInfoBarPrivate {
	GtkInfoBar* bar;
	GtkLabel* bar_label;
	GtkButton* bar_close_button;
	GtkProgressBar* bar_progress;
	gboolean shown;
	gint import_count;
	char* last_uri;
	guint import_notify_timeout;
};


static gpointer xnoise_mediawatcher_plugin_parent_class = NULL;
static XnoiseIPluginIface* xnoise_mediawatcher_plugin_xnoise_iplugin_parent_iface = NULL;
static GType xnoise_mediawatcher_plugin_type_id = 0;
static gpointer xnoise_mediawatcher_data_pair_parent_class = NULL;
static GType xnoise_mediawatcher_data_pair_type_id = 0;
static gpointer xnoise_mediawatcher_parent_class = NULL;
static GType xnoise_mediawatcher_type_id = 0;
static gpointer xnoise_import_info_bar_parent_class = NULL;
static GType xnoise_import_info_bar_type_id = 0;

GType xnoise_mediawatcher_plugin_get_type (void) G_GNUC_CONST;
GType xnoise_mediawatcher_plugin_register_type (GTypeModule * module);
GType xnoise_mediawatcher_get_type (void) G_GNUC_CONST;
GType xnoise_mediawatcher_register_type (GTypeModule * module);
#define XNOISE_MEDIAWATCHER_PLUGIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_MEDIAWATCHER_PLUGIN, XnoiseMediawatcherPluginPrivate))
enum  {
	XNOISE_MEDIAWATCHER_PLUGIN_DUMMY_PROPERTY,
	XNOISE_MEDIAWATCHER_PLUGIN_XN,
	XNOISE_MEDIAWATCHER_PLUGIN_NAME
};
static gboolean xnoise_mediawatcher_plugin_real_init (XnoiseIPlugin* base);
XnoiseMediawatcher* xnoise_mediawatcher_new (void);
XnoiseMediawatcher* xnoise_mediawatcher_construct (GType object_type);
static GtkWidget* xnoise_mediawatcher_plugin_real_get_settings_widget (XnoiseIPlugin* base);
static GtkWidget* xnoise_mediawatcher_plugin_real_get_singleline_settings_widget (XnoiseIPlugin* base);
static gboolean xnoise_mediawatcher_plugin_real_has_settings_widget (XnoiseIPlugin* base);
static gboolean xnoise_mediawatcher_plugin_real_has_singleline_settings_widget (XnoiseIPlugin* base);
XnoiseMediawatcherPlugin* xnoise_mediawatcher_plugin_new (void);
XnoiseMediawatcherPlugin* xnoise_mediawatcher_plugin_construct (GType object_type);
static void xnoise_mediawatcher_plugin_finalize (GObject* obj);
static void xnoise_mediawatcher_plugin_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void xnoise_mediawatcher_plugin_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType xnoise_mediawatcher_data_pair_get_type (void) G_GNUC_CONST;
GType xnoise_mediawatcher_data_pair_register_type (GTypeModule * module);
GType xnoise_import_info_bar_get_type (void) G_GNUC_CONST;
GType xnoise_import_info_bar_register_type (GTypeModule * module);
#define XNOISE_MEDIAWATCHER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_MEDIAWATCHER, XnoiseMediawatcherPrivate))
enum  {
	XNOISE_MEDIAWATCHER_DUMMY_PROPERTY
};
static void _g_list_free_g_object_unref (GList* self);
#define XNOISE_MEDIAWATCHER_monitoring_frequency 2000
static void xnoise_mediawatcher_media_path_changed_cb (XnoiseMediawatcher* self);
static void _xnoise_mediawatcher_media_path_changed_cb_xnoise_global_access_sig_media_path_changed (XnoiseGlobalAccess* _sender, gpointer self);
XnoiseImportInfoBar* xnoise_import_info_bar_new (void);
XnoiseImportInfoBar* xnoise_import_info_bar_construct (GType object_type);
static void xnoise_mediawatcher_setup_monitors_job (XnoiseMediawatcher* self, XnoiseWorkerJob* job);
static void _xnoise_mediawatcher_setup_monitors_job_xnoise_worker_sync_work_func (XnoiseWorkerJob* jb, gpointer self);
static void xnoise_mediawatcher_setup_monitor_for_path (XnoiseMediawatcher* self, const char* path);
static void xnoise_mediawatcher_file_changed_cb (XnoiseMediawatcher* self, GFileMonitor* sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type);
static void _xnoise_mediawatcher_file_changed_cb_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static XnoiseMediawatcherDataPair* xnoise_mediawatcher_data_pair_new (const char* path, GFileMonitor* monitor);
static XnoiseMediawatcherDataPair* xnoise_mediawatcher_data_pair_construct (GType object_type, const char* path, GFileMonitor* monitor);
static void xnoise_mediawatcher_monitor_all_subdirs (XnoiseMediawatcher* self, GFile* f);
static void xnoise_mediawatcher_remove_dir_monitors (XnoiseMediawatcher* self, const char* path);
static void _lambda4_ (void* data, Block1Data* _data1_);
static void __lambda4__gfunc (void* data, gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
static gboolean xnoise_mediawatcher_monitor_in_list (XnoiseMediawatcher* self, const char* path);
static void _lambda3_ (void* data, Block2Data* _data2_);
static void __lambda3__gfunc (void* data, gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (Block2Data* _data2_);
static void xnoise_mediawatcher_handle_deleted_file_job (XnoiseMediawatcher* self, XnoiseWorkerJob* job);
static void xnoise_mediawatcher_handle_created_file_job (XnoiseMediawatcher* self, XnoiseWorkerJob* job);
static void xnoise_mediawatcher_starter_method_async (XnoiseMediawatcher* self, XnoiseWorkerJob* job, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void xnoise_mediawatcher_starter_method_finish (XnoiseMediawatcher* self, GAsyncResult* _res_);
static void xnoise_mediawatcher_starter_method_async_data_free (gpointer _data);
static void xnoise_mediawatcher_starter_method_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean xnoise_mediawatcher_starter_method_async_co (XnoiseMediawatcherStarterMethodAsyncData* data);
static void xnoise_mediawatcher_async_worker (XnoiseMediawatcher* self, XnoiseWorkerJob* job, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void xnoise_mediawatcher_async_worker_finish (XnoiseMediawatcher* self, GAsyncResult* _res_);
static void xnoise_mediawatcher_async_worker_data_free (gpointer _data);
static void xnoise_mediawatcher_async_worker_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean xnoise_mediawatcher_async_worker_co (XnoiseMediawatcherAsyncWorkerData* data);
static void xnoise_mediawatcher_add_local_tags (XnoiseMediawatcher* self, GFile* dir, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void xnoise_mediawatcher_add_local_tags_finish (XnoiseMediawatcher* self, GAsyncResult* _res_);
static void xnoise_mediawatcher_add_local_tags_data_free (gpointer _data);
static void xnoise_mediawatcher_add_local_tags_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean xnoise_mediawatcher_add_local_tags_co (XnoiseMediawatcherAddLocalTagsData* data);
static gboolean xnoise_mediawatcher_low_prio_import_job (XnoiseMediawatcher* self, XnoiseWorkerJob* job);
static gboolean _xnoise_mediawatcher_low_prio_import_job_xnoise_worker_async_work_func (XnoiseWorkerJob* jb, gpointer self);
static void _vala_GValue_free (GValue* self);
static gboolean _lambda2_ (Block3Data* _data3_);
static gboolean __lambda2__gsource_func (gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (Block3Data* _data3_);
static void _xnoise_mediawatcher_handle_created_file_job_xnoise_worker_sync_work_func (XnoiseWorkerJob* jb, gpointer self);
static void _xnoise_mediawatcher_handle_deleted_file_job_xnoise_worker_sync_work_func (XnoiseWorkerJob* jb, gpointer self);
enum  {
	XNOISE_MEDIAWATCHER_DATA_PAIR_DUMMY_PROPERTY
};
static void xnoise_mediawatcher_data_pair_finalize (GObject* obj);
static void xnoise_mediawatcher_finalize (GObject* obj);
#define XNOISE_IMPORT_INFO_BAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_IMPORT_INFO_BAR, XnoiseImportInfoBarPrivate))
enum  {
	XNOISE_IMPORT_INFO_BAR_DUMMY_PROPERTY
};
#define XNOISE_IMPORT_INFO_BAR_notify_timeout_value 2500
static void _lambda0_ (GtkButton* a, XnoiseImportInfoBar* self);
static void __lambda0__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void xnoise_import_info_bar_on_import (XnoiseImportInfoBar* self, const char* uri);
static void _xnoise_import_info_bar_on_import_xnoise_global_access_sig_item_imported (XnoiseGlobalAccess* _sender, const char* uri, gpointer self);
static void xnoise_import_info_bar_on_ongoing_import (XnoiseImportInfoBar* self, const char* uri);
static gboolean xnoise_import_info_bar_on_countdown_done (XnoiseImportInfoBar* self);
static gboolean _xnoise_import_info_bar_on_countdown_done_gsource_func (gpointer self);
static void _xnoise_import_info_bar_on_ongoing_import_xnoise_global_access_sig_item_imported (XnoiseGlobalAccess* _sender, const char* uri, gpointer self);
static gboolean _lambda1_ (XnoiseImportInfoBar* self);
static gboolean __lambda1__gsource_func (gpointer self);
static void xnoise_import_info_bar_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gboolean xnoise_mediawatcher_plugin_real_init (XnoiseIPlugin* base) {
	XnoiseMediawatcherPlugin * self;
	gboolean result = FALSE;
	XnoiseMediawatcher* _tmp0_;
	self = (XnoiseMediawatcherPlugin*) base;
	self->watcher = (_tmp0_ = xnoise_mediawatcher_new (), _g_object_unref0 (self->watcher), _tmp0_);
	result = TRUE;
	return result;
}


static GtkWidget* xnoise_mediawatcher_plugin_real_get_settings_widget (XnoiseIPlugin* base) {
	XnoiseMediawatcherPlugin * self;
	GtkWidget* result = NULL;
	self = (XnoiseMediawatcherPlugin*) base;
	result = NULL;
	return result;
}


static GtkWidget* xnoise_mediawatcher_plugin_real_get_singleline_settings_widget (XnoiseIPlugin* base) {
	XnoiseMediawatcherPlugin * self;
	GtkWidget* result = NULL;
	self = (XnoiseMediawatcherPlugin*) base;
	result = NULL;
	return result;
}


static gboolean xnoise_mediawatcher_plugin_real_has_settings_widget (XnoiseIPlugin* base) {
	XnoiseMediawatcherPlugin * self;
	gboolean result = FALSE;
	self = (XnoiseMediawatcherPlugin*) base;
	result = FALSE;
	return result;
}


static gboolean xnoise_mediawatcher_plugin_real_has_singleline_settings_widget (XnoiseIPlugin* base) {
	XnoiseMediawatcherPlugin * self;
	gboolean result = FALSE;
	self = (XnoiseMediawatcherPlugin*) base;
	result = FALSE;
	return result;
}


XnoiseMediawatcherPlugin* xnoise_mediawatcher_plugin_construct (GType object_type) {
	XnoiseMediawatcherPlugin * self;
	self = (XnoiseMediawatcherPlugin*) g_object_new (object_type, NULL);
	return self;
}


XnoiseMediawatcherPlugin* xnoise_mediawatcher_plugin_new (void) {
	return xnoise_mediawatcher_plugin_construct (XNOISE_TYPE_MEDIAWATCHER_PLUGIN);
}


static XnoiseMain* xnoise_mediawatcher_plugin_real_get_xn (XnoiseIPlugin* base) {
	XnoiseMain* result;
	XnoiseMediawatcherPlugin* self;
	self = (XnoiseMediawatcherPlugin*) base;
	result = self->priv->_xn;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void xnoise_mediawatcher_plugin_real_set_xn (XnoiseIPlugin* base, XnoiseMain* value) {
	XnoiseMediawatcherPlugin* self;
	XnoiseMain* _tmp0_;
	self = (XnoiseMediawatcherPlugin*) base;
	self->priv->_xn = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_xn), _tmp0_);
	g_object_notify ((GObject *) self, "xn");
}


static const char* xnoise_mediawatcher_plugin_real_get_name (XnoiseIPlugin* base) {
	const char* result;
	XnoiseMediawatcherPlugin* self;
	self = (XnoiseMediawatcherPlugin*) base;
	result = "Mediawatcher";
	return result;
}


static void xnoise_mediawatcher_plugin_class_init (XnoiseMediawatcherPluginClass * klass) {
	xnoise_mediawatcher_plugin_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseMediawatcherPluginPrivate));
	G_OBJECT_CLASS (klass)->get_property = xnoise_mediawatcher_plugin_get_property;
	G_OBJECT_CLASS (klass)->set_property = xnoise_mediawatcher_plugin_set_property;
	G_OBJECT_CLASS (klass)->finalize = xnoise_mediawatcher_plugin_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_MEDIAWATCHER_PLUGIN_XN, "xn");
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_MEDIAWATCHER_PLUGIN_NAME, "name");
}


static void xnoise_mediawatcher_plugin_xnoise_iplugin_interface_init (XnoiseIPluginIface * iface) {
	xnoise_mediawatcher_plugin_xnoise_iplugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->init = xnoise_mediawatcher_plugin_real_init;
	iface->get_settings_widget = xnoise_mediawatcher_plugin_real_get_settings_widget;
	iface->get_singleline_settings_widget = xnoise_mediawatcher_plugin_real_get_singleline_settings_widget;
	iface->has_settings_widget = xnoise_mediawatcher_plugin_real_has_settings_widget;
	iface->has_singleline_settings_widget = xnoise_mediawatcher_plugin_real_has_singleline_settings_widget;
	iface->get_xn = xnoise_mediawatcher_plugin_real_get_xn;
	iface->set_xn = xnoise_mediawatcher_plugin_real_set_xn;
	iface->get_name = xnoise_mediawatcher_plugin_real_get_name;
}


static void xnoise_mediawatcher_plugin_instance_init (XnoiseMediawatcherPlugin * self) {
	self->priv = XNOISE_MEDIAWATCHER_PLUGIN_GET_PRIVATE (self);
}


static void xnoise_mediawatcher_plugin_finalize (GObject* obj) {
	XnoiseMediawatcherPlugin * self;
	self = XNOISE_MEDIAWATCHER_PLUGIN (obj);
	_g_object_unref0 (self->watcher);
	_g_object_unref0 (self->priv->_xn);
	G_OBJECT_CLASS (xnoise_mediawatcher_plugin_parent_class)->finalize (obj);
}


GType xnoise_mediawatcher_plugin_get_type (void) {
	return xnoise_mediawatcher_plugin_type_id;
}


GType xnoise_mediawatcher_plugin_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseMediawatcherPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_mediawatcher_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseMediawatcherPlugin), 0, (GInstanceInitFunc) xnoise_mediawatcher_plugin_instance_init, NULL };
	static const GInterfaceInfo xnoise_iplugin_info = { (GInterfaceInitFunc) xnoise_mediawatcher_plugin_xnoise_iplugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	xnoise_mediawatcher_plugin_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseMediawatcherPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, xnoise_mediawatcher_plugin_type_id, XNOISE_TYPE_IPLUGIN, &xnoise_iplugin_info);
	return xnoise_mediawatcher_plugin_type_id;
}


static void xnoise_mediawatcher_plugin_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	XnoiseMediawatcherPlugin * self;
	self = XNOISE_MEDIAWATCHER_PLUGIN (object);
	switch (property_id) {
		case XNOISE_MEDIAWATCHER_PLUGIN_XN:
		g_value_set_object (value, xnoise_iplugin_get_xn ((XnoiseIPlugin*) self));
		break;
		case XNOISE_MEDIAWATCHER_PLUGIN_NAME:
		g_value_set_string (value, xnoise_iplugin_get_name ((XnoiseIPlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void xnoise_mediawatcher_plugin_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	XnoiseMediawatcherPlugin * self;
	self = XNOISE_MEDIAWATCHER_PLUGIN (object);
	switch (property_id) {
		case XNOISE_MEDIAWATCHER_PLUGIN_XN:
		xnoise_iplugin_set_xn ((XnoiseIPlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


static void _xnoise_mediawatcher_media_path_changed_cb_xnoise_global_access_sig_media_path_changed (XnoiseGlobalAccess* _sender, gpointer self) {
	xnoise_mediawatcher_media_path_changed_cb (self);
}


static void _xnoise_mediawatcher_setup_monitors_job_xnoise_worker_sync_work_func (XnoiseWorkerJob* jb, gpointer self) {
	xnoise_mediawatcher_setup_monitors_job (self, jb);
}


XnoiseMediawatcher* xnoise_mediawatcher_construct (GType object_type) {
	XnoiseMediawatcher * self;
	GQueue* _tmp0_;
	XnoiseImportInfoBar* _tmp1_;
	XnoiseWorkerJob* job;
	self = (XnoiseMediawatcher*) g_object_new (object_type, NULL);
	self->priv->queue = (_tmp0_ = g_queue_new (), _g_queue_free0 (self->priv->queue), _tmp0_);
	g_signal_connect_object (xnoise_global, "sig-media-path-changed", (GCallback) _xnoise_mediawatcher_media_path_changed_cb_xnoise_global_access_sig_media_path_changed, self, 0);
	self->priv->iib = (_tmp1_ = xnoise_import_info_bar_new (), _g_object_unref0 (self->priv->iib), _tmp1_);
	job = xnoise_worker_job_new (1, XNOISE_WORKER_EXECUTION_TYPE_ONE_SHOT, NULL, NULL, _xnoise_mediawatcher_setup_monitors_job_xnoise_worker_sync_work_func, self);
	xnoise_worker_push_job (xnoise_worker, job);
	_g_object_unref0 (job);
	return self;
}


XnoiseMediawatcher* xnoise_mediawatcher_new (void) {
	return xnoise_mediawatcher_construct (XNOISE_TYPE_MEDIAWATCHER);
}


static void xnoise_mediawatcher_setup_monitors_job (XnoiseMediawatcher* self, XnoiseWorkerJob* job) {
	GList* _tmp0_;
	XnoiseDbBrowser* dbb;
	gint mfolders_length1;
	gint _mfolders_size_;
	char** _tmp4_;
	gint _tmp3_;
	char** mfolders;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (job != NULL);
	self->priv->monitor_list = (_tmp0_ = NULL, __g_list_free_g_object_unref0 (self->priv->monitor_list), _tmp0_);
	dbb = NULL;
	{
		XnoiseDbBrowser* _tmp1_;
		XnoiseDbBrowser* _tmp2_;
		_tmp1_ = xnoise_db_browser_new (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		dbb = (_tmp2_ = _tmp1_, _xnoise_db_browser_unref0 (dbb), _tmp2_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("%s\n", e->message);
			_g_error_free0 (e);
			_xnoise_db_browser_unref0 (dbb);
			return;
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_xnoise_db_browser_unref0 (dbb);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	mfolders = (_tmp4_ = xnoise_db_browser_get_media_folders (dbb, &_tmp3_), mfolders_length1 = _tmp3_, _mfolders_size_ = mfolders_length1, _tmp4_);
	{
		char** mfolder_collection;
		int mfolder_collection_length1;
		int mfolder_it;
		mfolder_collection = mfolders;
		mfolder_collection_length1 = mfolders_length1;
		for (mfolder_it = 0; mfolder_it < mfolders_length1; mfolder_it = mfolder_it + 1) {
			char* mfolder;
			mfolder = g_strdup (mfolder_collection[mfolder_it]);
			{
				xnoise_mediawatcher_setup_monitor_for_path (self, mfolder);
				_g_free0 (mfolder);
			}
		}
	}
	mfolders = (_vala_array_free (mfolders, mfolders_length1, (GDestroyNotify) g_free), NULL);
	_xnoise_db_browser_unref0 (dbb);
}


static void xnoise_mediawatcher_media_path_changed_cb (XnoiseMediawatcher* self) {
	XnoiseWorkerJob* job;
	g_return_if_fail (self != NULL);
	if (self->priv->monitor_list != NULL) {
		GList* iter;
		GList* _tmp0_;
		iter = self->priv->monitor_list;
		while (TRUE) {
			if (!((iter = iter->next) != NULL)) {
				break;
			}
			g_file_monitor_cancel (((XnoiseMediawatcherDataPair*) iter->data)->monitor);
			g_object_unref ((GObject*) ((XnoiseMediawatcherDataPair*) iter->data)->monitor);
		}
		g_file_monitor_cancel (((XnoiseMediawatcherDataPair*) self->priv->monitor_list->data)->monitor);
		g_object_unref ((GObject*) ((XnoiseMediawatcherDataPair*) self->priv->monitor_list->data)->monitor);
		self->priv->monitor_list = (_tmp0_ = NULL, __g_list_free_g_object_unref0 (self->priv->monitor_list), _tmp0_);
	}
	job = xnoise_worker_job_new (1, XNOISE_WORKER_EXECUTION_TYPE_ONE_SHOT, NULL, NULL, _xnoise_mediawatcher_setup_monitors_job_xnoise_worker_sync_work_func, self);
	xnoise_worker_push_job (xnoise_worker, job);
	_g_object_unref0 (job);
}


static void _xnoise_mediawatcher_file_changed_cb_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
	xnoise_mediawatcher_file_changed_cb (self, _sender, file, other_file, event_type);
}


static void xnoise_mediawatcher_setup_monitor_for_path (XnoiseMediawatcher* self, const char* path) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	{
		GFile* dir;
		GFileMonitor* monitor;
		XnoiseMediawatcherDataPair* d;
		dir = g_file_new_for_path (path);
		monitor = g_file_monitor_directory (dir, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (dir);
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch1_g_io_error;
			}
			_g_object_unref0 (dir);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		g_signal_connect_object (monitor, "changed", (GCallback) _xnoise_mediawatcher_file_changed_cb_g_file_monitor_changed, self, 0);
		g_file_monitor_set_rate_limit (monitor, XNOISE_MEDIAWATCHER_monitoring_frequency);
		d = xnoise_mediawatcher_data_pair_new (path, monitor);
		g_object_ref ((GObject*) monitor);
		self->priv->monitor_list = g_list_append (self->priv->monitor_list, _g_object_ref0 (d));
		xnoise_mediawatcher_monitor_all_subdirs (self, dir);
		_g_object_unref0 (d);
		_g_object_unref0 (monitor);
		_g_object_unref0 (dir);
	}
	goto __finally1;
	__catch1_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("Could not setup file monitoring for \'%s\': Error %s\n", path, e->message);
			_g_error_free0 (e);
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void _lambda4_ (void* data, Block1Data* _data1_) {
	XnoiseMediawatcher * self;
	GList* iter;
	self = _data1_->self;
	iter = self->priv->monitor_list;
	while (TRUE) {
		if (!(iter != NULL)) {
			break;
		}
		if (g_str_has_prefix (((XnoiseMediawatcherDataPair*) iter->data)->path, _data1_->path)) {
			GList* temp;
			g_print ("removed monitor %s", ((XnoiseMediawatcherDataPair*) iter->data)->path);
			g_file_monitor_cancel (((XnoiseMediawatcherDataPair*) iter->data)->monitor);
			g_object_unref ((GObject*) ((XnoiseMediawatcherDataPair*) iter->data)->monitor);
			temp = iter->next;
			iter = g_list_delete_link (iter, iter);
			iter = temp;
			g_print ("REMOVE\n");
		} else {
			iter = iter->next;
		}
	}
}


static void __lambda4__gfunc (void* data, gpointer self) {
	_lambda4_ (data, self);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_object_unref0 (_data1_->self);
		_g_free0 (_data1_->path);
		g_slice_free (Block1Data, _data1_);
	}
}


static void xnoise_mediawatcher_remove_dir_monitors (XnoiseMediawatcher* self, const char* path) {
	Block1Data* _data1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_data1_->path = g_strdup (path);
	g_list_foreach (self->priv->monitor_list, __lambda4__gfunc, _data1_);
	block1_data_unref (_data1_);
}


static void _lambda3_ (void* data, Block2Data* _data2_) {
	XnoiseMediawatcher * self;
	GList* iter;
	self = _data2_->self;
	iter = self->priv->monitor_list;
	while (TRUE) {
		if (!(iter != NULL)) {
			break;
		}
		if (_vala_strcmp0 (((XnoiseMediawatcherDataPair*) iter->data)->path, _data2_->path) == 0) {
			_data2_->success = TRUE;
		}
		iter = iter->next;
	}
}


static void __lambda3__gfunc (void* data, gpointer self) {
	_lambda3_ (data, self);
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (Block2Data* _data2_) {
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		_g_object_unref0 (_data2_->self);
		_g_free0 (_data2_->path);
		g_slice_free (Block2Data, _data2_);
	}
}


static gboolean xnoise_mediawatcher_monitor_in_list (XnoiseMediawatcher* self, const char* path) {
	gboolean result = FALSE;
	Block2Data* _data2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_data2_->path = g_strdup (path);
	_data2_->success = FALSE;
	g_list_foreach (self->priv->monitor_list, __lambda3__gfunc, _data2_);
	result = _data2_->success;
	block2_data_unref (_data2_);
	return result;
}


static char* string_replace (const char* self, const char* old, const char* replacement) {
	char* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp2_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_assert_not_reached ();
			_g_error_free0 (e);
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void xnoise_mediawatcher_handle_deleted_file_job (XnoiseMediawatcher* self, XnoiseWorkerJob* job) {
	GFile* file;
	char* _tmp0_;
	XnoiseDbWriter* dbw;
	char* _tmp3_;
	gboolean _tmp4_;
	char* _tmp13_;
	char* _tmp14_;
	XnoiseDbWriter* _tmp15_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (job != NULL);
	file = g_value_get_object (xnoise_worker_job_get_arg (job, "file"));
	g_print ("File deleted: \'%s\'\n", _tmp0_ = g_file_get_path (file));
	_g_free0 (_tmp0_);
	dbw = NULL;
	if (dbw == NULL) {
		{
			XnoiseDbWriter* _tmp1_;
			XnoiseDbWriter* _tmp2_;
			_tmp1_ = xnoise_db_writer_new (&_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch2_g_error;
			}
			dbw = (_tmp2_ = _tmp1_, _g_object_unref0 (dbw), _tmp2_);
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				g_print ("%s\n", e->message);
				_g_error_free0 (e);
				_g_object_unref0 (dbw);
				_g_object_unref0 (file);
				return;
			}
		}
		__finally2:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (dbw);
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if ((_tmp4_ = xnoise_mediawatcher_monitor_in_list (self, _tmp3_ = g_file_get_path (file)), _g_free0 (_tmp3_), _tmp4_)) {
		char* _tmp5_;
		XnoiseDbBrowser* dbb;
		char* search_string;
		char* _tmp8_;
		char* _tmp9_;
		char* _tmp10_;
		gint results_length1;
		gint _results_size_;
		char** _tmp12_;
		gint _tmp11_;
		char** results;
		g_print ("%s was a directory\n", _tmp5_ = g_file_get_path (file));
		_g_free0 (_tmp5_);
		dbb = NULL;
		{
			XnoiseDbBrowser* _tmp6_;
			XnoiseDbBrowser* _tmp7_;
			_tmp6_ = xnoise_db_browser_new (&_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
			}
			dbb = (_tmp7_ = _tmp6_, _xnoise_db_browser_unref0 (dbb), _tmp7_);
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				g_print ("%s\n", e->message);
				_g_error_free0 (e);
				_xnoise_db_browser_unref0 (dbb);
				_g_object_unref0 (dbw);
				_g_object_unref0 (file);
				return;
			}
		}
		__finally3:
		if (_inner_error_ != NULL) {
			_xnoise_db_browser_unref0 (dbb);
			_g_object_unref0 (dbw);
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		search_string = g_file_get_uri (file);
		search_string = (_tmp8_ = string_replace (search_string, "%", "\\%"), _g_free0 (search_string), _tmp8_);
		search_string = (_tmp9_ = string_replace (search_string, "_", "\\_"), _g_free0 (search_string), _tmp9_);
		search_string = (_tmp10_ = g_strconcat (search_string, "/%", NULL), _g_free0 (search_string), _tmp10_);
		results = (_tmp12_ = xnoise_db_browser_get_uris (dbb, search_string, &_tmp11_), results_length1 = _tmp11_, _results_size_ = results_length1, _tmp12_);
		{
			char** a_collection;
			int a_collection_length1;
			int a_it;
			a_collection = results;
			a_collection_length1 = results_length1;
			for (a_it = 0; a_it < results_length1; a_it = a_it + 1) {
				char* a;
				a = g_strdup (a_collection[a_it]);
				{
					g_print ("deleting %s from db\n", a);
					xnoise_db_writer_delete_uri (dbw, a);
					_g_free0 (a);
				}
			}
		}
		results = (_vala_array_free (results, results_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (search_string);
		_xnoise_db_browser_unref0 (dbb);
	}
	xnoise_db_writer_delete_uri (dbw, _tmp13_ = g_file_get_uri (file));
	_g_free0 (_tmp13_);
	xnoise_mediawatcher_remove_dir_monitors (self, _tmp14_ = g_file_get_path (file));
	_g_free0 (_tmp14_);
	dbw = (_tmp15_ = NULL, _g_object_unref0 (dbw), _tmp15_);
	_g_object_unref0 (dbw);
	_g_object_unref0 (file);
}


static void xnoise_mediawatcher_handle_created_file_job (XnoiseMediawatcher* self, XnoiseWorkerJob* job) {
	GFile* file;
	char* _tmp0_;
	char* buffer;
	g_return_if_fail (self != NULL);
	g_return_if_fail (job != NULL);
	file = g_value_get_object (xnoise_worker_job_get_arg (job, "file"));
	g_print ("\'%s\' has been created recently, updating db...\n", _tmp0_ = g_file_get_path (file));
	_g_free0 (_tmp0_);
	buffer = g_file_get_path (file);
	g_queue_push_tail (self->priv->queue, g_strdup (buffer));
	if (self->priv->queue->length > 0) {
		xnoise_mediawatcher_starter_method_async (self, job, NULL, NULL);
	}
	_g_free0 (buffer);
	_g_object_unref0 (file);
}


static void xnoise_mediawatcher_starter_method_async_data_free (gpointer _data) {
	XnoiseMediawatcherStarterMethodAsyncData* data;
	data = _data;
	_g_object_unref0 (data->job);
	g_object_unref (data->self);
	g_slice_free (XnoiseMediawatcherStarterMethodAsyncData, data);
}


static void xnoise_mediawatcher_starter_method_async (XnoiseMediawatcher* self, XnoiseWorkerJob* job, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	XnoiseMediawatcherStarterMethodAsyncData* _data_;
	_data_ = g_slice_new0 (XnoiseMediawatcherStarterMethodAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, xnoise_mediawatcher_starter_method_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, xnoise_mediawatcher_starter_method_async_data_free);
	_data_->self = g_object_ref (self);
	_data_->job = _g_object_ref0 (job);
	xnoise_mediawatcher_starter_method_async_co (_data_);
}


static void xnoise_mediawatcher_starter_method_finish (XnoiseMediawatcher* self, GAsyncResult* _res_) {
	XnoiseMediawatcherStarterMethodAsyncData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void xnoise_mediawatcher_starter_method_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	XnoiseMediawatcherStarterMethodAsyncData* data;
	data = _user_data_;
	data->_res_ = _res_;
	xnoise_mediawatcher_starter_method_async_co (data);
}


static gboolean xnoise_mediawatcher_starter_method_async_co (XnoiseMediawatcherStarterMethodAsyncData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 1:
		goto _state_1;
	}
	_state_0:
	if (data->self->priv->async_running == TRUE) {
		{
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
	}
	while (TRUE) {
		if (!(data->self->priv->queue->length > 0)) {
			break;
		}
		data->self->priv->async_running = TRUE;
		data->_state_ = 1;
		xnoise_mediawatcher_async_worker (data->self, data->job, xnoise_mediawatcher_starter_method_async_ready, data);
		return FALSE;
		_state_1:
		xnoise_mediawatcher_async_worker_finish (data->self, data->_res_);
	}
	data->self->priv->async_running = FALSE;
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


static void xnoise_mediawatcher_async_worker_data_free (gpointer _data) {
	XnoiseMediawatcherAsyncWorkerData* data;
	data = _data;
	_g_object_unref0 (data->job);
	g_object_unref (data->self);
	g_slice_free (XnoiseMediawatcherAsyncWorkerData, data);
}


static void xnoise_mediawatcher_async_worker (XnoiseMediawatcher* self, XnoiseWorkerJob* job, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	XnoiseMediawatcherAsyncWorkerData* _data_;
	_data_ = g_slice_new0 (XnoiseMediawatcherAsyncWorkerData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, xnoise_mediawatcher_async_worker);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, xnoise_mediawatcher_async_worker_data_free);
	_data_->self = g_object_ref (self);
	_data_->job = _g_object_ref0 (job);
	xnoise_mediawatcher_async_worker_co (_data_);
}


static void xnoise_mediawatcher_async_worker_finish (XnoiseMediawatcher* self, GAsyncResult* _res_) {
	XnoiseMediawatcherAsyncWorkerData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void xnoise_mediawatcher_async_worker_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	XnoiseMediawatcherAsyncWorkerData* data;
	data = _user_data_;
	data->_res_ = _res_;
	xnoise_mediawatcher_async_worker_co (data);
}


static gboolean xnoise_mediawatcher_async_worker_co (XnoiseMediawatcherAsyncWorkerData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	data->path = g_strdup ((const char*) g_queue_peek_head (data->self->priv->queue));
	if (data->path == NULL) {
		_g_free0 (data->path);
		{
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
	}
	g_print ("\nHANDLE QUEUE for %s\n", data->path);
	data->file = g_file_new_for_path (data->path);
	data->_tmp0_ = (char*) g_queue_pop_head (data->self->priv->queue);
	_g_free0 (data->_tmp0_);
	{
		data->info = g_file_query_info (data->file, G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &data->_inner_error_);
		if (data->_inner_error_ != NULL) {
			goto __catch5_g_error;
		}
		if (g_file_info_get_file_type (data->info) == G_FILE_TYPE_REGULAR) {
			xnoise_media_importer_add_single_file (xnoise_media_importer, data->_tmp1_ = g_file_get_uri (data->file));
			_g_free0 (data->_tmp1_);
		} else {
			if (g_file_info_get_file_type (data->info) == G_FILE_TYPE_DIRECTORY) {
				xnoise_mediawatcher_add_local_tags (data->self, data->file, NULL, NULL);
				g_print ("++1\n");
			}
		}
		_g_object_unref0 (data->info);
	}
	goto __finally5;
	__catch5_g_error:
	{
		data->e2 = data->_inner_error_;
		data->_inner_error_ = NULL;
		{
			g_print ("Adding of \'%s\' failed: Error: %s\n", data->_tmp2_ = g_file_get_path (data->file), data->e2->message);
			_g_free0 (data->_tmp2_);
			_g_error_free0 (data->e2);
		}
	}
	__finally5:
	if (data->_inner_error_ != NULL) {
		_g_object_unref0 (data->file);
		_g_free0 (data->path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
	_g_object_unref0 (data->file);
	_g_free0 (data->path);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


static void xnoise_mediawatcher_add_local_tags_data_free (gpointer _data) {
	XnoiseMediawatcherAddLocalTagsData* data;
	data = _data;
	_g_object_unref0 (data->dir);
	g_object_unref (data->self);
	g_slice_free (XnoiseMediawatcherAddLocalTagsData, data);
}


static void xnoise_mediawatcher_add_local_tags (XnoiseMediawatcher* self, GFile* dir, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	XnoiseMediawatcherAddLocalTagsData* _data_;
	_data_ = g_slice_new0 (XnoiseMediawatcherAddLocalTagsData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, xnoise_mediawatcher_add_local_tags);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, xnoise_mediawatcher_add_local_tags_data_free);
	_data_->self = g_object_ref (self);
	_data_->dir = _g_object_ref0 (dir);
	xnoise_mediawatcher_add_local_tags_co (_data_);
}


static void xnoise_mediawatcher_add_local_tags_finish (XnoiseMediawatcher* self, GAsyncResult* _res_) {
	XnoiseMediawatcherAddLocalTagsData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void xnoise_mediawatcher_add_local_tags_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	XnoiseMediawatcherAddLocalTagsData* data;
	data = _user_data_;
	data->_res_ = _res_;
	xnoise_mediawatcher_add_local_tags_co (data);
}


static gboolean _xnoise_mediawatcher_low_prio_import_job_xnoise_worker_async_work_func (XnoiseWorkerJob* jb, gpointer self) {
	gboolean result;
	result = xnoise_mediawatcher_low_prio_import_job (self, jb);
	return result;
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


static gboolean xnoise_mediawatcher_add_local_tags_co (XnoiseMediawatcherAddLocalTagsData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		case 4:
		goto _state_4;
	}
	_state_0:
	data->attr = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE);
	{
		data->_state_ = 2;
		g_file_enumerate_children_async (data->dir, data->attr, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, xnoise_mediawatcher_add_local_tags_ready, data);
		return FALSE;
		_state_2:
		data->_tmp0_ = g_file_enumerate_children_finish (data->dir, data->_res_, &data->_inner_error_);
		if (data->_inner_error_ != NULL) {
			goto __catch6_g_error;
		}
		data->enumerator = (data->_tmp1_ = data->_tmp0_, _g_object_unref0 (data->enumerator), data->_tmp1_);
	}
	goto __finally6;
	__catch6_g_error:
	{
		data->_error_ = data->_inner_error_;
		data->_inner_error_ = NULL;
		{
			g_critical ("xnoise-mediawatcher.vala:324: Error importing directory %s. %s\n", data->_tmp2_ = g_file_get_path (data->dir), data->_error_->message);
			_g_free0 (data->_tmp2_);
			_g_error_free0 (data->_error_);
			_g_free0 (data->attr);
			_g_object_unref0 (data->enumerator);
			{
				if (data->_state_ == 0) {
					g_simple_async_result_complete_in_idle (data->_async_result);
				} else {
					g_simple_async_result_complete (data->_async_result);
				}
				g_object_unref (data->_async_result);
				return FALSE;
			}
			_g_error_free0 (data->_error_);
		}
	}
	__finally6:
	if (data->_inner_error_ != NULL) {
		_g_free0 (data->attr);
		_g_object_unref0 (data->enumerator);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
	{
		while (TRUE) {
			data->_state_ = 3;
			g_file_enumerator_next_files_async (data->enumerator, 15, G_PRIORITY_DEFAULT, NULL, xnoise_mediawatcher_add_local_tags_ready, data);
			return FALSE;
			_state_3:
			data->_tmp3_ = g_file_enumerator_next_files_finish (data->enumerator, data->_res_, &data->_inner_error_);
			if (data->_inner_error_ != NULL) {
				goto __catch7_g_error;
			}
			data->infos = (data->_tmp4_ = data->_tmp3_, __g_list_free_g_object_unref0 (data->infos), data->_tmp4_);
			if (data->infos == NULL) {
				__g_list_free_g_object_unref0 (data->infos);
				_g_free0 (data->attr);
				_g_object_unref0 (data->enumerator);
				{
					if (data->_state_ == 0) {
						g_simple_async_result_complete_in_idle (data->_async_result);
					} else {
						g_simple_async_result_complete (data->_async_result);
					}
					g_object_unref (data->_async_result);
					return FALSE;
				}
			}
			{
				data->info_collection = data->infos;
				for (data->info_it = data->info_collection; data->info_it != NULL; data->info_it = data->info_it->next) {
					data->info = _g_object_ref0 ((GFileInfo*) data->info_it->data);
					{
						data->filename = g_strdup (g_file_info_get_name (data->info));
						data->filepath = (data->_tmp6_ = g_build_filename (data->_tmp5_ = g_file_get_path (data->dir), data->filename, NULL), _g_free0 (data->_tmp5_), data->_tmp6_);
						data->file = g_file_new_for_path (data->filepath);
						data->filetype = g_file_info_get_file_type (data->info);
						data->content = g_strdup (g_file_info_get_content_type (data->info));
						data->mime = g_content_type_get_mime_type (data->content);
						data->psAudio = g_pattern_spec_new ("audio*");
						data->psVideo = g_pattern_spec_new ("video*");
						if (data->filetype == G_FILE_TYPE_DIRECTORY) {
							data->_state_ = 4;
							xnoise_mediawatcher_add_local_tags (data->self, data->file, xnoise_mediawatcher_add_local_tags_ready, data);
							return FALSE;
							_state_4:
							xnoise_mediawatcher_add_local_tags_finish (data->self, data->_res_);
							xnoise_mediawatcher_setup_monitor_for_path (data->self, data->_tmp7_ = g_file_get_path (data->file));
							_g_free0 (data->_tmp7_);
						} else {
							if (g_pattern_match_string (data->psAudio, data->mime)) {
								data->uri_lc = g_utf8_strdown (data->filepath, -1);
								if (g_str_has_suffix (data->uri_lc, ".m3u")) {
									data->_tmp11_ = TRUE;
								} else {
									data->_tmp11_ = g_str_has_suffix (data->uri_lc, ".pls");
								}
								if (data->_tmp11_) {
									data->_tmp10_ = TRUE;
								} else {
									data->_tmp10_ = g_str_has_suffix (data->uri_lc, ".asx");
								}
								if (data->_tmp10_) {
									data->_tmp9_ = TRUE;
								} else {
									data->_tmp9_ = g_str_has_suffix (data->uri_lc, ".xspf");
								}
								if (data->_tmp9_) {
									data->_tmp8_ = TRUE;
								} else {
									data->_tmp8_ = g_str_has_suffix (data->uri_lc, ".wpl");
								}
								if (!data->_tmp8_) {
									data->job = xnoise_worker_job_new (33, XNOISE_WORKER_EXECUTION_TYPE_REPEATED_LOW_PRIORITY, _xnoise_mediawatcher_low_prio_import_job_xnoise_worker_async_work_func, data->self, NULL, NULL);
									data->nm = g_file_get_uri (data->file);
									data->_tmp12_ = NULL;
									xnoise_worker_job_set_arg (data->job, "uri", (data->_tmp12_ = g_new0 (GValue, 1), g_value_init (data->_tmp12_, G_TYPE_STRING), g_value_set_string (data->_tmp12_, data->nm), data->_tmp12_));
									__vala_GValue_free0 (data->_tmp12_);
									xnoise_worker_push_job (xnoise_worker, data->job);
									_g_free0 (data->nm);
									_g_object_unref0 (data->job);
								}
								_g_free0 (data->uri_lc);
							}
						}
						_g_pattern_spec_free0 (data->psVideo);
						_g_pattern_spec_free0 (data->psAudio);
						_g_free0 (data->mime);
						_g_free0 (data->content);
						_g_object_unref0 (data->file);
						_g_free0 (data->filepath);
						_g_free0 (data->filename);
						_g_object_unref0 (data->info);
					}
				}
			}
			_xnoise_track_data_unref0 (data->td);
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		data->e = data->_inner_error_;
		data->_inner_error_ = NULL;
		{
			g_print ("%s\n", data->e->message);
			_g_error_free0 (data->e);
		}
	}
	__finally7:
	if (data->_inner_error_ != NULL) {
		__g_list_free_g_object_unref0 (data->infos);
		_g_free0 (data->attr);
		_g_object_unref0 (data->enumerator);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
	__g_list_free_g_object_unref0 (data->infos);
	_g_free0 (data->attr);
	_g_object_unref0 (data->enumerator);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	__g_list_free_g_object_unref0 (data->infos);
	_g_free0 (data->attr);
	_g_object_unref0 (data->enumerator);
	{
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
}


static gpointer _xnoise_track_data_ref0 (gpointer self) {
	return self ? xnoise_track_data_ref (self) : NULL;
}


static gboolean _lambda2_ (Block3Data* _data3_) {
	XnoiseMediawatcher * self;
	gboolean result = FALSE;
	self = _data3_->self;
	xnoise_media_browser_model_insert_trackdata_sorted (xnoise_main_get_instance ()->main_window->mediaBr->mediabrowsermodel, _data3_->tdy, _data3_->tdy_length1);
	result = FALSE;
	return result;
}


static gboolean __lambda2__gsource_func (gpointer self) {
	gboolean result;
	result = _lambda2_ (self);
	return result;
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (Block3Data* _data3_) {
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		_g_object_unref0 (_data3_->self);
		_data3_->tdy = (_vala_array_free (_data3_->tdy, _data3_->tdy_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
		g_slice_free (Block3Data, _data3_);
	}
}


static gboolean xnoise_mediawatcher_low_prio_import_job (XnoiseMediawatcher* self, XnoiseWorkerJob* job) {
	gboolean result = FALSE;
	XnoiseDbWriter* dbw;
	char* _tmp2_;
	GFile* _tmp3_;
	GFile* f;
	char* _tmp4_;
	gint _tmp5_;
	gint idbuffer;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (job != NULL, FALSE);
	g_print ("low prio job!\n");
	dbw = NULL;
	{
		XnoiseDbWriter* _tmp0_;
		XnoiseDbWriter* _tmp1_;
		_tmp0_ = xnoise_db_writer_new (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch8_g_error;
		}
		dbw = (_tmp1_ = _tmp0_, _g_object_unref0 (dbw), _tmp1_);
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("%s\n", e->message);
			_g_error_free0 (e);
		}
	}
	__finally8:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (dbw);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	f = (_tmp3_ = g_file_new_for_uri (_tmp2_ = g_value_get_string (xnoise_worker_job_get_arg (job, "uri"))), _g_free0 (_tmp2_), _tmp3_);
	idbuffer = (_tmp5_ = xnoise_db_writer_uri_entry_exists (dbw, _tmp4_ = g_file_get_uri (f)), _g_free0 (_tmp4_), _tmp5_);
	if (idbuffer == (-1)) {
		Block3Data* _data3_;
		XnoiseTagReader* tr;
		char* _tmp6_;
		XnoiseTrackData* _tmp7_;
		XnoiseTrackData* td;
		char* _tmp8_;
		XnoiseTrackData** _tmp10_;
		XnoiseTrackData** _tmp9_ = NULL;
		_data3_ = g_slice_new0 (Block3Data);
		_data3_->_ref_count_ = 1;
		_data3_->self = g_object_ref (self);
		tr = xnoise_tag_reader_new ();
		td = (_tmp7_ = xnoise_tag_reader_read_tag (tr, _tmp6_ = g_file_get_path (f)), _g_free0 (_tmp6_), _tmp7_);
		td->db_id = xnoise_db_writer_insert_title (dbw, td, _tmp8_ = g_file_get_uri (f));
		_g_free0 (_tmp8_);
		_data3_->tdy = (_tmp10_ = (_tmp9_ = g_new0 (XnoiseTrackData*, 1 + 1), _tmp9_[0] = _xnoise_track_data_ref0 (td), _tmp9_), _data3_->tdy_length1 = 1, _tmp10_);
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda2__gsource_func, block3_data_ref (_data3_), block3_data_unref);
		_xnoise_track_data_unref0 (td);
		_xnoise_tag_reader_unref0 (tr);
		block3_data_unref (_data3_);
	}
	result = FALSE;
	_g_object_unref0 (f);
	_g_object_unref0 (dbw);
	return result;
}


static void _xnoise_mediawatcher_handle_created_file_job_xnoise_worker_sync_work_func (XnoiseWorkerJob* jb, gpointer self) {
	xnoise_mediawatcher_handle_created_file_job (self, jb);
}


static void _xnoise_mediawatcher_handle_deleted_file_job_xnoise_worker_sync_work_func (XnoiseWorkerJob* jb, gpointer self) {
	xnoise_mediawatcher_handle_deleted_file_job (self, jb);
}


static void xnoise_mediawatcher_file_changed_cb (XnoiseMediawatcher* self, GFileMonitor* sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (file != NULL);
	if (!xnoise_global_access_get_media_import_in_progress (xnoise_global)) {
		GEnumValue* _tmp0_;
		g_print ("%s\n", (_tmp0_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), (int) event_type), (_tmp0_ != NULL) ? _tmp0_->value_name : NULL));
		if (event_type == G_FILE_MONITOR_EVENT_CREATED) {
			if (file != NULL) {
				XnoiseWorkerJob* job;
				GValue* _tmp1_ = NULL;
				job = xnoise_worker_job_new (1, XNOISE_WORKER_EXECUTION_TYPE_ONE_SHOT, NULL, NULL, _xnoise_mediawatcher_handle_created_file_job_xnoise_worker_sync_work_func, self);
				xnoise_worker_job_set_arg (job, "file", (_tmp1_ = g_new0 (GValue, 1), g_value_init (_tmp1_, G_TYPE_FILE), g_value_set_object (_tmp1_, file), _tmp1_));
				__vala_GValue_free0 (_tmp1_);
				xnoise_worker_push_job (xnoise_worker, job);
				_g_object_unref0 (job);
			}
		}
		if (event_type == G_FILE_MONITOR_EVENT_DELETED) {
			if (file != NULL) {
				XnoiseWorkerJob* job;
				GValue* _tmp2_ = NULL;
				job = xnoise_worker_job_new (1, XNOISE_WORKER_EXECUTION_TYPE_ONE_SHOT, NULL, NULL, _xnoise_mediawatcher_handle_deleted_file_job_xnoise_worker_sync_work_func, self);
				xnoise_worker_job_set_arg (job, "file", (_tmp2_ = g_new0 (GValue, 1), g_value_init (_tmp2_, G_TYPE_FILE), g_value_set_object (_tmp2_, file), _tmp2_));
				__vala_GValue_free0 (_tmp2_);
				xnoise_worker_push_job (xnoise_worker, job);
				_g_object_unref0 (job);
			}
		}
	}
}


static void xnoise_mediawatcher_monitor_all_subdirs (XnoiseMediawatcher* self, GFile* f) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (f != NULL);
	{
		GFileEnumerator* enumerator;
		GFileInfo* info;
		enumerator = g_file_enumerate_children (f, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch9_g_io_error;
			}
			goto __catch9_g_error;
		}
		info = NULL;
		while (TRUE) {
			GFileInfo* _tmp0_;
			GFileInfo* _tmp1_;
			_tmp0_ = g_file_enumerator_next_file (enumerator, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_object_unref0 (info);
				_g_object_unref0 (enumerator);
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch9_g_io_error;
				}
				goto __catch9_g_error;
			}
			if (!((info = (_tmp1_ = _tmp0_, _g_object_unref0 (info), _tmp1_)) != NULL)) {
				break;
			}
			if (g_file_info_get_file_type (info) == G_FILE_TYPE_DIRECTORY) {
				char* _tmp2_;
				char* _tmp3_;
				GFile* _tmp4_;
				GFile* temp_f;
				GFileMonitor* temp_mon;
				char* _tmp5_;
				XnoiseMediawatcherDataPair* _tmp6_;
				XnoiseMediawatcherDataPair* d;
				temp_f = (_tmp4_ = g_file_new_for_path (_tmp3_ = g_build_filename (_tmp2_ = g_file_get_path (f), g_file_info_get_name (info), NULL, NULL)), _g_free0 (_tmp3_), _g_free0 (_tmp2_), _tmp4_);
				temp_mon = g_file_monitor_directory (temp_f, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
				if (_inner_error_ != NULL) {
					_g_object_unref0 (temp_f);
					_g_object_unref0 (info);
					_g_object_unref0 (enumerator);
					if (_inner_error_->domain == G_IO_ERROR) {
						goto __catch9_g_io_error;
					}
					goto __catch9_g_error;
				}
				g_signal_connect_object (temp_mon, "changed", (GCallback) _xnoise_mediawatcher_file_changed_cb_g_file_monitor_changed, self, 0);
				g_file_monitor_set_rate_limit (temp_mon, XNOISE_MEDIAWATCHER_monitoring_frequency);
				d = (_tmp6_ = xnoise_mediawatcher_data_pair_new (_tmp5_ = g_file_get_path (temp_f), temp_mon), _g_free0 (_tmp5_), _tmp6_);
				g_object_ref ((GObject*) temp_mon);
				self->priv->monitor_list = g_list_append (self->priv->monitor_list, _g_object_ref0 (d));
				xnoise_mediawatcher_monitor_all_subdirs (self, temp_f);
				_g_object_unref0 (d);
				_g_object_unref0 (temp_mon);
				_g_object_unref0 (temp_f);
			}
		}
		_g_object_unref0 (info);
		_g_object_unref0 (enumerator);
	}
	goto __finally9;
	__catch9_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("Setting up file monitoring: Error: %s\n", e->message);
			_g_error_free0 (e);
		}
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("Setting up file monitoring: Error: %s\n", e->message);
			_g_error_free0 (e);
		}
	}
	__finally9:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static XnoiseMediawatcherDataPair* xnoise_mediawatcher_data_pair_construct (GType object_type, const char* path, GFileMonitor* monitor) {
	XnoiseMediawatcherDataPair * self;
	char* _tmp0_;
	GFileMonitor* _tmp1_;
	g_return_val_if_fail (path != NULL, NULL);
	g_return_val_if_fail (monitor != NULL, NULL);
	self = (XnoiseMediawatcherDataPair*) g_object_new (object_type, NULL);
	self->path = (_tmp0_ = g_strdup (path), _g_free0 (self->path), _tmp0_);
	self->monitor = (_tmp1_ = _g_object_ref0 (monitor), _g_object_unref0 (self->monitor), _tmp1_);
	return self;
}


static XnoiseMediawatcherDataPair* xnoise_mediawatcher_data_pair_new (const char* path, GFileMonitor* monitor) {
	return xnoise_mediawatcher_data_pair_construct (XNOISE_MEDIAWATCHER_TYPE_DATA_PAIR, path, monitor);
}


static void xnoise_mediawatcher_data_pair_class_init (XnoiseMediawatcherDataPairClass * klass) {
	xnoise_mediawatcher_data_pair_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = xnoise_mediawatcher_data_pair_finalize;
}


static void xnoise_mediawatcher_data_pair_instance_init (XnoiseMediawatcherDataPair * self) {
}


static void xnoise_mediawatcher_data_pair_finalize (GObject* obj) {
	XnoiseMediawatcherDataPair * self;
	self = XNOISE_MEDIAWATCHER_DATA_PAIR (obj);
	_g_object_unref0 (self->monitor);
	_g_free0 (self->path);
	G_OBJECT_CLASS (xnoise_mediawatcher_data_pair_parent_class)->finalize (obj);
}


GType xnoise_mediawatcher_data_pair_get_type (void) {
	return xnoise_mediawatcher_data_pair_type_id;
}


GType xnoise_mediawatcher_data_pair_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseMediawatcherDataPairClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_mediawatcher_data_pair_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseMediawatcherDataPair), 0, (GInstanceInitFunc) xnoise_mediawatcher_data_pair_instance_init, NULL };
	xnoise_mediawatcher_data_pair_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseMediawatcherDataPair", &g_define_type_info, 0);
	return xnoise_mediawatcher_data_pair_type_id;
}


static void xnoise_mediawatcher_class_init (XnoiseMediawatcherClass * klass) {
	xnoise_mediawatcher_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseMediawatcherPrivate));
	G_OBJECT_CLASS (klass)->finalize = xnoise_mediawatcher_finalize;
}


static void xnoise_mediawatcher_instance_init (XnoiseMediawatcher * self) {
	self->priv = XNOISE_MEDIAWATCHER_GET_PRIVATE (self);
	self->priv->monitor_list = NULL;
	self->priv->async_running = FALSE;
}


static void xnoise_mediawatcher_finalize (GObject* obj) {
	XnoiseMediawatcher * self;
	self = XNOISE_MEDIAWATCHER (obj);
	__g_list_free_g_object_unref0 (self->priv->monitor_list);
	_g_object_unref0 (self->priv->iib);
	_g_queue_free0 (self->priv->queue);
	G_OBJECT_CLASS (xnoise_mediawatcher_parent_class)->finalize (obj);
}


GType xnoise_mediawatcher_get_type (void) {
	return xnoise_mediawatcher_type_id;
}


GType xnoise_mediawatcher_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseMediawatcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_mediawatcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseMediawatcher), 0, (GInstanceInitFunc) xnoise_mediawatcher_instance_init, NULL };
	xnoise_mediawatcher_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseMediawatcher", &g_define_type_info, 0);
	return xnoise_mediawatcher_type_id;
}


static void _lambda0_ (GtkButton* a, XnoiseImportInfoBar* self) {
	g_return_if_fail (a != NULL);
	gtk_widget_hide ((GtkWidget*) self->priv->bar);
	self->priv->import_count = 0;
	self->priv->shown = FALSE;
}


static void __lambda0__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_lambda0_ (_sender, self);
}


static void _xnoise_import_info_bar_on_import_xnoise_global_access_sig_item_imported (XnoiseGlobalAccess* _sender, const char* uri, gpointer self) {
	xnoise_import_info_bar_on_import (self, uri);
}


XnoiseImportInfoBar* xnoise_import_info_bar_construct (GType object_type) {
	XnoiseImportInfoBar * self;
	GtkInfoBar* _tmp0_;
	GtkLabel* _tmp1_;
	GtkWidget* content_area;
	GtkImage* close_image;
	GtkButton* _tmp2_;
	GtkProgressBar* _tmp3_;
	self = (XnoiseImportInfoBar*) g_object_new (object_type, NULL);
	self->priv->import_count = 0;
	self->priv->bar = (_tmp0_ = g_object_ref_sink ((GtkInfoBar*) gtk_info_bar_new ()), _g_object_unref0 (self->priv->bar), _tmp0_);
	self->priv->bar_label = (_tmp1_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->bar_label), _tmp1_);
	g_object_set ((GtkWidget*) self->priv->bar_label, "height-request", 20, NULL);
	content_area = _g_object_ref0 (gtk_info_bar_get_content_area (self->priv->bar));
	gtk_container_add (GTK_CONTAINER (content_area), (GtkWidget*) self->priv->bar_label);
	gtk_widget_show ((GtkWidget*) self->priv->bar_label);
	close_image = g_object_ref_sink ((GtkImage*) gtk_image_new_from_stock (GTK_STOCK_CLOSE, GTK_ICON_SIZE_MENU));
	self->priv->bar_close_button = (_tmp2_ = g_object_ref_sink ((GtkButton*) gtk_button_new ()), _g_object_unref0 (self->priv->bar_close_button), _tmp2_);
	gtk_button_set_image (self->priv->bar_close_button, (GtkWidget*) close_image);
	gtk_button_set_relief (self->priv->bar_close_button, GTK_RELIEF_NONE);
	gtk_widget_show ((GtkWidget*) close_image);
	gtk_widget_set_size_request ((GtkWidget*) self->priv->bar_close_button, 0, 0);
	gtk_info_bar_add_action_widget (self->priv->bar, (GtkWidget*) self->priv->bar_close_button, 0);
	self->priv->bar_progress = (_tmp3_ = g_object_ref_sink ((GtkProgressBar*) gtk_progress_bar_new ()), _g_object_unref0 (self->priv->bar_progress), _tmp3_);
	gtk_progress_bar_set_pulse_step (self->priv->bar_progress, 0.01);
	g_object_set (self->priv->bar_progress, "bar-style", GTK_PROGRESS_CONTINUOUS, NULL);
	gtk_container_add (GTK_CONTAINER (content_area), (GtkWidget*) self->priv->bar_progress);
	g_signal_connect_object (self->priv->bar_close_button, "clicked", (GCallback) __lambda0__gtk_button_clicked, self, 0);
	g_signal_connect_object (xnoise_global, "sig-item-imported", (GCallback) _xnoise_import_info_bar_on_import_xnoise_global_access_sig_item_imported, self, 0);
	_g_object_unref0 (close_image);
	_g_object_unref0 (content_area);
	return self;
}


XnoiseImportInfoBar* xnoise_import_info_bar_new (void) {
	return xnoise_import_info_bar_construct (XNOISE_TYPE_IMPORT_INFO_BAR);
}


static gboolean _xnoise_import_info_bar_on_countdown_done_gsource_func (gpointer self) {
	gboolean result;
	result = xnoise_import_info_bar_on_countdown_done (self);
	return result;
}


static void xnoise_import_info_bar_on_ongoing_import (XnoiseImportInfoBar* self, const char* uri) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (uri != NULL);
	self->priv->import_count++;
	self->priv->last_uri = (_tmp0_ = NULL, _g_free0 (self->priv->last_uri), _tmp0_);
	if (gtk_widget_get_realized ((GtkWidget*) self->priv->bar_progress)) {
		gtk_progress_bar_pulse (self->priv->bar_progress);
	}
	g_source_remove (self->priv->import_notify_timeout);
	self->priv->import_notify_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) XNOISE_IMPORT_INFO_BAR_notify_timeout_value, _xnoise_import_info_bar_on_countdown_done_gsource_func, g_object_ref (self), g_object_unref);
}


static void _xnoise_import_info_bar_on_ongoing_import_xnoise_global_access_sig_item_imported (XnoiseGlobalAccess* _sender, const char* uri, gpointer self) {
	xnoise_import_info_bar_on_ongoing_import (self, uri);
}


static void xnoise_import_info_bar_on_import (XnoiseImportInfoBar* self, const char* uri) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (uri != NULL);
	if (!xnoise_global_access_get_media_import_in_progress (xnoise_global)) {
		char* _tmp1_;
		guint _tmp2_;
		if (self->priv->bar_label == NULL) {
			GtkLabel* _tmp0_;
			self->priv->bar_label = (_tmp0_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->bar_label), _tmp0_);
		}
		gtk_label_set_text (self->priv->bar_label, "Adding new files to the media database...");
		self->priv->import_count++;
		self->priv->last_uri = (_tmp1_ = g_strdup (uri), _g_free0 (self->priv->last_uri), _tmp1_);
		if (self->priv->shown == FALSE) {
			xnoise_main_window_display_info_bar (xnoise_main_get_instance ()->main_window, self->priv->bar);
			self->priv->shown = TRUE;
		}
		gtk_widget_hide ((GtkWidget*) self->priv->bar_close_button);
		gtk_widget_show ((GtkWidget*) self->priv->bar_progress);
		gtk_progress_bar_pulse (self->priv->bar_progress);
		gtk_widget_show ((GtkWidget*) self->priv->bar);
		self->priv->import_notify_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) XNOISE_IMPORT_INFO_BAR_notify_timeout_value, _xnoise_import_info_bar_on_countdown_done_gsource_func, g_object_ref (self), g_object_unref);
		g_signal_parse_name ("sig-item-imported", XNOISE_TYPE_GLOBAL_ACCESS, &_tmp2_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (xnoise_global, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _xnoise_import_info_bar_on_import_xnoise_global_access_sig_item_imported, self);
		g_signal_connect_object (xnoise_global, "sig-item-imported", (GCallback) _xnoise_import_info_bar_on_ongoing_import_xnoise_global_access_sig_item_imported, self, 0);
	}
}


static gboolean _lambda1_ (XnoiseImportInfoBar* self) {
	gboolean result = FALSE;
	if (gtk_widget_get_realized ((GtkWidget*) self->priv->bar_label)) {
		char* _tmp0_;
		char* _tmp1_;
		gtk_label_set_text (self->priv->bar_label, _tmp1_ = g_strconcat (_tmp0_ = g_strdup_printf ("%i", self->priv->import_count), " items have been added to your media library", NULL));
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
	}
	result = FALSE;
	return result;
}


static gboolean __lambda1__gsource_func (gpointer self) {
	gboolean result;
	result = _lambda1_ (self);
	return result;
}


static gboolean xnoise_import_info_bar_on_countdown_done (XnoiseImportInfoBar* self) {
	gboolean result = FALSE;
	guint _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->bar_label == NULL) {
		GtkLabel* _tmp0_;
		self->priv->bar_label = (_tmp0_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->bar_label), _tmp0_);
	}
	if (self->priv->import_count > 1) {
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda1__gsource_func, g_object_ref (self), g_object_unref);
	} else {
		XnoiseDbBrowser* dbb;
		XnoiseTrackData* data;
		XnoiseTrackData* _tmp3_ = NULL;
		XnoiseTrackData* _tmp4_;
		char* _tmp9_;
		dbb = NULL;
		{
			XnoiseDbBrowser* _tmp1_;
			XnoiseDbBrowser* _tmp2_;
			_tmp1_ = xnoise_db_browser_new (&_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch10_g_error;
			}
			dbb = (_tmp2_ = _tmp1_, _xnoise_db_browser_unref0 (dbb), _tmp2_);
		}
		goto __finally10;
		__catch10_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				g_print ("%s\n", e->message);
				result = FALSE;
				_g_error_free0 (e);
				_xnoise_db_browser_unref0 (dbb);
				return result;
			}
		}
		__finally10:
		if (_inner_error_ != NULL) {
			_xnoise_db_browser_unref0 (dbb);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		data = NULL;
		xnoise_db_browser_get_trackdata_for_uri (dbb, self->priv->last_uri, &_tmp3_);
		data = (_tmp4_ = _tmp3_, _xnoise_track_data_unref0 (data), _tmp4_);
		if (gtk_widget_get_realized ((GtkWidget*) self->priv->bar_label)) {
			char* _tmp5_;
			char* _tmp6_;
			char* _tmp7_;
			char* _tmp8_;
			gtk_label_set_markup (self->priv->bar_label, _tmp8_ = g_strconcat (_tmp7_ = g_strconcat (_tmp6_ = g_strconcat (_tmp5_ = g_strconcat ("<b>", data->Artist, NULL), " - ", NULL), data->Title, NULL), "</b> has been added to your media library", NULL));
			_g_free0 (_tmp8_);
			_g_free0 (_tmp7_);
			_g_free0 (_tmp6_);
			_g_free0 (_tmp5_);
		}
		self->priv->last_uri = (_tmp9_ = NULL, _g_free0 (self->priv->last_uri), _tmp9_);
		_xnoise_track_data_unref0 (data);
		_xnoise_db_browser_unref0 (dbb);
	}
	gtk_widget_hide ((GtkWidget*) self->priv->bar_progress);
	gtk_widget_show ((GtkWidget*) self->priv->bar_close_button);
	g_signal_parse_name ("sig-item-imported", XNOISE_TYPE_GLOBAL_ACCESS, &_tmp10_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (xnoise_global, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _xnoise_import_info_bar_on_ongoing_import_xnoise_global_access_sig_item_imported, self);
	g_signal_connect_object (xnoise_global, "sig-item-imported", (GCallback) _xnoise_import_info_bar_on_import_xnoise_global_access_sig_item_imported, self, 0);
	result = FALSE;
	return result;
}


static void xnoise_import_info_bar_class_init (XnoiseImportInfoBarClass * klass) {
	xnoise_import_info_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseImportInfoBarPrivate));
	G_OBJECT_CLASS (klass)->finalize = xnoise_import_info_bar_finalize;
}


static void xnoise_import_info_bar_instance_init (XnoiseImportInfoBar * self) {
	self->priv = XNOISE_IMPORT_INFO_BAR_GET_PRIVATE (self);
	self->priv->bar = NULL;
	self->priv->bar_label = NULL;
	self->priv->bar_close_button = NULL;
	self->priv->bar_progress = NULL;
	self->priv->last_uri = NULL;
}


static void xnoise_import_info_bar_finalize (GObject* obj) {
	XnoiseImportInfoBar * self;
	self = XNOISE_IMPORT_INFO_BAR (obj);
	_g_object_unref0 (self->priv->bar);
	_g_object_unref0 (self->priv->bar_label);
	_g_object_unref0 (self->priv->bar_close_button);
	_g_object_unref0 (self->priv->bar_progress);
	_g_free0 (self->priv->last_uri);
	G_OBJECT_CLASS (xnoise_import_info_bar_parent_class)->finalize (obj);
}


GType xnoise_import_info_bar_get_type (void) {
	return xnoise_import_info_bar_type_id;
}


GType xnoise_import_info_bar_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseImportInfoBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_import_info_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseImportInfoBar), 0, (GInstanceInitFunc) xnoise_import_info_bar_instance_init, NULL };
	xnoise_import_info_bar_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseImportInfoBar", &g_define_type_info, 0);
	return xnoise_import_info_bar_type_id;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




